<?php
// image functions customized to GD specifications
function restore($image_path)
{ // replace the temp file with the original
 if (strstr($image_path, 'temp_'))
 {
  $orig = str_replace('temp_', '', $image_path);
  @copy($orig, $image_path);
 }
 else $orig = $image_path;
 $img = prepare($orig);
 output($img);
 return true;
}

function grayscale($image_path)
{
 $img = prepare($image_path);
 $dither = true;
 imagetruecolortopalette($img, $dither, 255); // for function to work, must be 256 color
 for ($i=0; $i < imagecolorstotal($img); $i++)
 {
  $index = imagecolorsforindex($img, $i);
  $average = (int)((int)($index["red"] + $index["green"] + $index["blue"]) / 3);
  $set = imagecolorset($img, $i, $average, $average, $average);
 }
 output($img);
 return true;
}

function negate($image_path)
{
 $img = prepare($image_path);
 $dither = true;
 imagetruecolortopalette($img, $dither, 255); // for function to work, must be 256 color
 for ($i=0; $i<imagecolorstotal($img); $i++)
 {
  $index = imagecolorsforindex($img, $i);
  if ($index["red"] > 128)
  {
   $newred = $index["red"] - 128;
   $newred = 128 - $newred;
  }
  else 
  {
   $newred = 128 - $index["red"];
   $newred = 128 + $newred;
  }
  if ($index["green"] > 128)
  {
   $newgreen = $index["green"] - 128;
   $newgreen = 128 - $newgreen;
  }
  else 
  {
   $newgreen = 128 - $index["green"];
   $newgreen = 128 + $newgreen;
  }
  if ($index["blue"] > 128)
  {
   $newrblue = $index["blue"] - 128;
   $newblue = 128 - $newblue;
  }
  else 
  {
   $newblue = 128 - $index["blue"];
   $newblue = 128 + $newblue;
  }
  $set = imagecolorset($img, $i, $newred, $newgreen, $newblue);
 }
 output($img);
}

function output($img)
{
 global $image_path, $settings, $outputtype, $thelink, $thefiletype;
 if (strlen($outputtype) < 2) $outputtype = $settings->outputtype;
 $extension = extension($image_path);  
 if ($thefiletype) $extension = $thefiletype;
 if (strlen($outputtype) < 2) $outputtype = $extension;
 $thelink->filetitle = str_replace($extension, $outputtype, $thelink->filetitle);     
 switch ($outputtype)
 {
  case 'png':
   $thelink->filetitle = str_replace($extension, 'png', $thelink->filetitle);   
   if ($action == 'download') header("Content-Disposition: attachment; filename=". $thelink->filetitle);     
   header("Content-type: image/png");
   imagepng($img);
   die();
   break;
  case 'jpeg':
  case 'jpg':
   if ($settings->jpeginterlace == 'yes') imageinterlace($img, 1);
   header("Content-type: image/jpeg");
   imagejpeg($img, '', $settings->jpegquality);
   die();
   break;
  case 'gif':
   imagetruecolortopalette($img, $dither, 255); // for function to work, must be 256 color    
   if ($action == 'download') header("Content-Disposition: attachment; filename=". $thelink->filetitle);     
   header("Content-type: image/gif");
   imagegif($img);   
   die();
   break;
  case 'bmp':
   if ($action == 'download') header("Content-Disposition: attachment; filename=". $thelink->filetitle);     
   header("Content-type: image/x-xbitmap");
   imagexbm($img);
 }
 imagedestroy($img);
 return true;
}

function prepare($image_path)
{
 global $thefiletype;	
 $ext = extension($image_path);
 if ($thefiletype) $ext = $thefiletype; 
 if ($ext == 'jpg' || $ext == 'jpeg')
 {
  $img = @imagecreatefromjpeg($image_path);
 }
 else if ($ext == 'png') 
 {
  $img = @imagecreatefrompng($image_path);
 }
 else if ($ext == 'gif') 
 {
  $img = @imagecreatefromgif($image_path);
 }
 else if ($ext == 'bmp')
 {
  $img = @imagecreatefromwbmp($image_path);
 } 
 return $img;
}

function pngtojpg($image_path)
{
 global $settings;
 $img = @imagecreatefrompng($image_path);
 $newname = str_replace('.png', '.jpg', $image_path); 
 imagejpeg($img, $newname);
 return true;	
}

function makethumbnail($image_path, $maxwidth, $maxheight)
{ 
 global $dontsave, $thelink, $debug, $templatesdir, $fixedsize, $thefiletype, $attachedid, $flvthumb;
 $img = null;
 $ext = extension($image_path);
 if ($thefiletype) $extension = $thefiletype; 
 if ($ext == 'wsn' || !$ext) $ext = extension($thelink->filetitle);
 if (($ext == 'jpg') || ($ext == 'jpeg'))
 {
  $img = @imagecreatefromjpeg($image_path);
 }
 else if ($ext == 'png') 
 {
  $img = @imagecreatefrompng($image_path);
 }
 else if ($ext == 'gif')
 {
  $img = @imagecreatefromgif($image_path);
 }
 else $img = false; 

 if ($img)
 {
  $width = imagesx($img);
  $height = imagesy($img);
  $scale = min($maxwidth/$width, $maxheight/$height);

  if ($scale < 1)
  {
   if ($fixedsize)
   {
    $new_width = $maxwidth; 
    $new_height = $maxheight;
   }
   else
   {
    $new_width = floor($scale*$width);
    $new_height = floor($scale*$height);
   }
   if (function_exists(imagecreatetruecolor))
   {
    $tmp_img = imagecreatetruecolor($new_width, $new_height);
   }
   else
   {
    $tmp_img = imagecreate($new_width, $new_height);
   }
   @imagecopyresampled($tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
   @imagedestroy($img);
   $img = $tmp_img;
  }
 }

 if (!$img)
 {
  $dontsave = true;
  $img = @imagecreatefrompng($templatesdir .'/images/'. $ext .'.png'); 
  if (!$img) $img = imagecreatefrompng($templatesdir .'/images/nothumbnail.png'); 
  $width = imagesx($img);
  $height = imagesy($img);
  $scale = min($maxwidth/$width, $maxheight/$height);
  // If the image is larger than the max shrink it
  if ($scale < 1)
  {
   $new_width = floor($scale * $width);
   $new_height = floor($scale * $height);
   $tmp_img = @imagecreatetruecolor($new_width, $new_height);
   @imagecopyresampled($tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
   @imagedestroy($img);
   $img = $tmp_img;
  }
 }

if ($flvthumb) $saveas = $flvthumb;
else
{
 $saveas = str_replace($thelink->filename, 'thumb_'. $thelink->filename, $image_path);
 $saveas = str_replace('.'. extension($thelink->filename), $attachedid .'.jpg', $saveas);
}

 if (!$dontsave) imagejpeg($img, $saveas);
 header("Content-type: image/jpeg");
 imagejpeg($img);
 die();
}

function sitethumbnail($image_path, $maxwidth, $maxheight)
{ 
 global $dontsave, $thelink, $debug, $templatesdir, $fixedsize, $thefiletype;
 $img = null;
 $img = imagecreatefrompng($image_path);
 $width = imagesx($img);
 $height = imagesy($img);
 $scale = min($maxwidth/$width, $maxheight/$height);
 if ($scale < 1)
 {
   if ($fixedsize)
   {
    $new_width = $maxwidth; 
    $new_height = $maxheight;
   }
   else
   {
    $new_width = floor($scale*$width);
    $new_height = floor($scale*$height);
   }
   if (function_exists(imagecreatetruecolor))
   {
    $tmp_img = imagecreatetruecolor($new_width, $new_height);
   }
   else
   {
    $tmp_img = imagecreate($new_width, $new_height);
   }
   @imagecopyresampled($tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
   @imagedestroy($img);
   $img = $tmp_img;
 }
 imagepng($img, $image_path);
 return true; 
}

function resizeimage($image_path, $maxwidth, $maxheight)
{
 global $debug, $templatesdir, $fixedsize, $thefiletype;
 $img = null;
 $ext = extension($image_path);
 if ($thefiletype) $ext = $thefiletype; 
 if ($ext == 'wsn') $ext = 'jpg'; // take a guess if all else fails
 if (($ext == 'jpg') || ($ext == 'jpeg'))
 {
  $img = @imagecreatefromjpeg($image_path);
 }
 else if ($ext == 'png')
 {
  $img = @imagecreatefrompng($image_path);
 }
 else if ($ext == 'gif')
 {
  $img = @imagecreatefromgif($image_path);
 }
 else if ($ext == 'bmp')
 {
  $img = false;
 }

 if ($img)
 {
  $width = imagesx($img);
  $height = imagesy($img);
  $scale = min($maxwidth/$width, $maxheight/$height);
  if ($scale < 1)
  {
   if ($fixedsize)
   {
    $new_width = $maxwidth;
    $new_height = $maxheight;
   }
   else
   {
    $new_width = floor($scale*$width);
    $new_height = floor($scale*$height);
   }
   if (function_exists(imagecreatetruecolor))
   {
    $tmp_img = imagecreatetruecolor($new_width, $new_height);
   }
   else
   {
    $tmp_img = imagecreate($new_width, $new_height);
   }
   @imagecopyresampled($tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
   @imagedestroy($img);
   $img = $tmp_img;
  }
 }
 imagejpeg($img, $image_path);
}

function watermark($image_path)
{ 
 global $settings, $debug;
 $padding = $settings->waterpadding; // watermark will be this many pixels from the corner
 $quality = 100; // best quality 
 $watercorner = $settings->watercorner;
 $size = getimagesize($image_path); 
 $width = $size[0]; $height = $size[1]; $type = $size[2];
 if ($settings->watertext)
 {
  $chars = strlen($settings->watertext); 
  $waterwidth = 10 * $chars;
  $waterheight = 20;
 }
 else 
 { 
  $waterpath = $settings->uploadpath . $settings->watermark; 
  $size = getimagesize($waterpath);
  $waterwidth = $size[0]; $waterheight = $size[1];
 }  
 switch ($watercorner)
 {
  case 'northwest':
  $placementx = $padding;
  $placementy = $padding;
  break;  
  case 'northeast':
  $placementx = $width - $waterwidth - $padding;
  $placementy = $padding; 
  break;  
  case 'southwest':
  $placementx = $padding;
  $placementy = $height - $waterheight - $padding;
  break;  
  case 'southeast': 
  $placementx = $width - $waterwidth - $padding;
  $placementy = $height - $waterheight - $padding;  
  break;  
 }
 if ($type==3) $resultImage = imagecreatefrompng($image_path);
 else $resultImage = imagecreatefromjpeg($image_path);
 imagealphablending($resultImage, TRUE);
 if ($settings->watertext)
 {
  $c = explode(',', $settings->watertextcolor);
  $textcolor = imagecolorallocate($resultImage, $c[0], $c[1], $c[2]);  
  imagestring($resultImage, $settings->watertextsize, $placementx, $placementy, $settings->watertext, $textcolor);  
 }
 else
 { 
  $finalWaterMarkImage = imagecreatefrompng($waterpath);
  imagecopy($resultImage, $finalWaterMarkImage, $placementx, $placementy, 0, 0, $waterwidth, $waterheight);
 }  
 if($type[2]==3)
 {
   imagealphablending($resultImage,FALSE);
   imagesavealpha($resultImage,TRUE);
   imagepng($resultImage, $image_path, $quality);
 }
 else
 {
   imagejpeg($resultImage, $image_path, $quality); 
 }
 imagedestroy($resultImage);
 if (!$settings->watertext) imagedestroy($finalWaterMarkImage); 
 return true;
}
?>